// quantum computing emulation: H timing
//
// R. Perry, June 2020
//
#include <stdio.h>
#include <stdlib.h> // atoi()

// #define REAL
#include "qce.h"

//---------------------------------------------------------------------

int main( int argc, char *argv[])
{
  unsigned int qn = 2; if( argc > 1) qn = atoi(argv[1]);
  if( qn < 2) error( "HC: bad qn arg");

  State q = Q(qn); unsigned int seed = SRAND(); init( q, 1, 1);
  printf( "HC: seed = %u, n = %u, N = %lu\n", seed, q.n, q.N);
  if( qn < 5) print( "q", q, 0);

  for( unsigned int k = 0; k < q.n; ++k) H( q, k);
  if( qn < 5) print( "Hq", q, 0);

  for( unsigned int k = 0; k < q.n; ++k) H( q, k);
  if( qn < 5) print( "HHq", q, 0);

  return 0;
}
